=== debian/changelog ===
awesome (4.0-1) unstable; urgency=medium

  * New upstream release. Closes: #850701, #851791.
    + d/patches:
      - Refreshed.
      - Drop Prevent_clients_from_being_lost_on_RANRD_changes.patch.
    + d/control:
      - Add B-D against libxcb-xrm-dev, libxcb-xkb-dev,
        libxkbcommon-x11-dev and libxkbcommon-dev.
      - Add B-D against lua-lgi (needed for docs/*.md).
    + d/docs: README renamed to README.md.
    + d/rules: Disable integration tests (currently fails).

 -- Arnaud Fontaine <arnau@debian.org>  Thu, 19 Jan 2017 15:25:32 +0900
