## awesome 4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,20 @@
 cmake_minimum_required(VERSION 3.0.0)
+project(awesome C)
+
+# Require an out-of-source build. We generate an awesomerc.lua in the build dir
+# from the one in the source dir and this does not work otherwise.
+if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
+    message(SEND_ERROR "\
+You appear to be doing an in-source build, which means that the binaries are \
+generated in the same directory where the source code is. This is currently not \
+supported. Instead, do, for example, the following:\n\
+   mkdir build && cd build && cmake ..\n\
+Beware that CMake likely already generated a CMakeCache.txt in the source \
+directory which you first have to delete. \
+")
+    message(FATAL_ERROR "In-source builds are not supported")
+endif()
+
 set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS  TRUE)
 
 if(COMMAND cmake_policy)
@@ -23,9 +39,6 @@
     ${AWESOME_OPTIONAL_INCLUDE_DIRS})
 
 set(CHECK_TARGETS check-integration)
-
-set(AWE_CONF_FILE_DEFAULT ${BUILD_DIR}/awesomerc.lua)
-set(AWE_CONF_FILE rc.lua)
 
 set(AWE_ICON_DIR ${SOURCE_DIR}/icons)
 set(AWE_THEMES_DIR ${SOURCE_DIR}/themes)
@@ -281,10 +294,14 @@
     file(COPY ${SOURCE_DIR}/docs/aliases DESTINATION ${BUILD_DIR}/docs)
 
     add_custom_target(ldoc ALL
+        DEPENDS ${BUILD_DIR}/doc/index.html)
+    add_custom_command(
         COMMAND ${LDOC_EXECUTABLE} .
+        OUTPUT  ${BUILD_DIR}/doc/index.html
         WORKING_DIRECTORY ${AWE_DOC_DIR}
-        DEPENDS ${AWE_LUA_FILES} ${AWE_MD_FILES}
-    )
+        DEPENDS ${AWE_LUA_FILES} ${AWE_MD_FILES} ${BUILD_DIR}/docs/config.ld
+        COMMENT "Generating API documentation"
+        VERBATIM)
 
     # Run ldoc and make it fail if any warnings are generated. The
     # redirection-magic swaps stdout and stderr and awk exits with a non-zero
@@ -328,28 +345,3 @@
 
 foreach(icon ${ALL_ICONS})
     # Make unfocused icons translucent
-    a_icon_convert("_focus" "_normal" ${icon}
-        -colorspace rgb -gamma 0.6 -channel A -evaluate Multiply 0.4)
-endforeach()
-
-foreach(icon ${ALL_ICONS})
-    # Make inactive icons grayscale
-    a_icon_convert("_active" "_inactive" ${icon}
-        -colorspace Gray)
-endforeach()
-
-add_custom_target(generated_icons ALL DEPENDS ${ALL_ICONS})
-# }}}
-
-# {{{ Dist tarball
-if(BUILD_FROM_GIT)
-    add_custom_target(dist
-        COMMAND ${SOURCE_DIR}/build-utils/dist.sh ${VERSION}
-        WORKING_DIRECTORY ${SOURCE_DIR})
-endif()
-# }}}
-
-# {{{ Installation
-install(TARGETS ${PROJECT_AWE_NAME} RUNTIME DESTINATION bin)
-install(FILES "utils/awesome-client" DESTINATION bin PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
-install(DIRECTORY ${BUILD_DIR}/lib DESTINATION ${AWESOME_DATA_PATH}
