=== tests/examples/CMakeLists.txt ===
--- 
+++ 
@@ -14,20 +14,45 @@
 # Get and update the LUA_PATH so the scripts can be executed without Awesome.
 execute_process(COMMAND lua -e print\(package.path\) OUTPUT_VARIABLE "LUA_PATH_")
 
+# Make sure the system can be called from the test directory
+if(NOT SOURCE_DIR AND ${CMAKE_CURRENT_SOURCE_DIR} MATCHES "/tests/examples")
+    get_filename_component(TOP_SOURCE_DIR
+                           "${CMAKE_CURRENT_SOURCE_DIR}/../.." ABSOLUTE)
+    # Used by .luacov.
+    set(ENV{SOURCE_DIRECTORY} ${TOP_SOURCE_DIR})
+else()
+    set(TOP_SOURCE_DIR ${CMAKE_SOURCE_DIR})
+endif()
+
+if (DEFINED ENV{DO_COVERAGE} AND NOT $ENV{DO_COVERAGE} STREQUAL "0")
+  execute_process(
+    COMMAND lua -e "require('luacov.runner')('${TOP_SOURCE_DIR}/.luacov')"
+    RESULT_VARIABLE TEST_RESULT
+    ERROR_VARIABLE  TEST_ERROR
+    ERROR_STRIP_TRAILING_WHITESPACE)
+  if (TEST_RESULT OR NOT TEST_ERROR STREQUAL "")
+    message(${TEST_ERROR})
+    message(FATAL_ERROR "Failed to run luacov.runner.")
+  endif()
+  set(LUA_COV_RUNNER lua "-erequire('luacov.runner')('${TOP_SOURCE_DIR}/.luacov')")
+else()
+  set(LUA_COV_RUNNER lua)
+endif()
+
 # Add the main awesome lua libraries.
 set(LUA_PATH2_ "\
-${CMAKE_SOURCE_DIR}/lib/?.lua;\
-${CMAKE_SOURCE_DIR}/lib/?/init.lua;\
-${CMAKE_SOURCE_DIR}/lib/?;\
-${CMAKE_SOURCE_DIR}/themes/?.lua;\
-${CMAKE_SOURCE_DIR}/themes/?;"
+${TOP_SOURCE_DIR}/lib/?.lua;\
+${TOP_SOURCE_DIR}/lib/?/init.lua;\
+${TOP_SOURCE_DIR}/lib/?;\
+${TOP_SOURCE_DIR}/themes/?.lua;\
+${TOP_SOURCE_DIR}/themes/?;"
 )
 
 # Add the C API shims.
 set(LUA_PATH3_ "\
-${CMAKE_SOURCE_DIR}/tests/examples/shims/?.lua;\
-${CMAKE_SOURCE_DIR}/tests/examples/shims/?/init.lua;\
-${CMAKE_SOURCE_DIR}/tests/examples/shims/?;"
+${TOP_SOURCE_DIR}/tests/examples/shims/?.lua;\
+${TOP_SOURCE_DIR}/tests/examples/shims/?/init.lua;\
+${TOP_SOURCE_DIR}/tests/examples/shims/?;"
 )
 
 # Done in 3 variables to avoid CMake from implicitly converting into a list.
@@ -57,8 +82,8 @@
 
     set(tmp_output ${content})
     foreach (LINE ${var_lines})
-        if(NOT LINE MATCHES "^.+--DOC_[A-Z]+$")
-            set(tmp_output ${tmp_output}\n--${line_prefix}${LINE})
+        if(NOT LINE MATCHES "^.*--DOC_[A-Z]+")
+            set(tmp_output ${tmp_output}\n${DOC_LINE_PREFIX}${line_prefix}${LINE})
         endif()
     endforeach()
 
@@ -92,8 +117,8 @@
         endif()
     endforeach()
 
-    set(${post_output} "${tmp_post_output}\n--" PARENT_SCOPE)
-    set(${pre_output} "${tmp_pre_output}\n--" PARENT_SCOPE)
+    set(${post_output} "${tmp_post_output}\n${DOC_LINE_PREFIX}" PARENT_SCOPE)
+    set(${pre_output} "${tmp_pre_output}\n${DOC_LINE_PREFIX}" PARENT_SCOPE)
 endfunction()
 
 # Read a code file and convert it to ldoc usage example.
@@ -104,7 +129,7 @@
 function(escape_code path escaped_content pre_header post_header)
     file(READ ${path} path)
 
-    escape_string("${path}\n" "" escaped_code "")
+    escape_string("${path}\n" "" escaped_code " ")
 
     extract_header("${path}" example_pre_header example_post_header)
 
@@ -133,7 +158,7 @@
 # Get the namespace of a file.
 function(get_namespace result_variable file)
     get_filename_component(path "${file}" DIRECTORY)
-    string(LENGTH "${SOURCE_DIR}/tests/examples" prefix_length)
+    string(LENGTH "${TOP_SOURCE_DIR}/tests/examples" prefix_length)
     string(REPLACE "/" "_" namespace "${path}")
     string(SUBSTRING "${namespace}" "${prefix_length}" -1 namespace)
 
@@ -144,28 +169,40 @@
 function(run_test test_path namespace escaped_content)
     find_template(template "${test_path}")
 
+    file(READ ${test_path} tmp_content)
+
+    # Add "--" in front of each line. This is required for method doc, but not
+    # for documentation pages
+    if(NOT tmp_content MATCHES "--DOC_NO_DASH")
+        set(DOC_LINE_PREFIX "--")
+    endif()
+
+    # Do not use the @usage tag, but 4 spaces.
+    if(NOT tmp_content MATCHES "--DOC_NO_USAGE")
+        set(DOC_BLOCK_PREFIX "@usage")
+    endif()
+
     # Get the file name without the extension.
     get_filename_component(${test_path} TEST_FILE_NAME NAME)
     set(IMAGE_PATH "${IMAGE_DIR}/AUTOGEN${namespace}_${TEST_FILE_NAME}")
-
-    # Use the example testing as coverage source.
-    if (USE_LCOV)
-        set(LCOV_PATH ${SOURCE_DIR}/.luacov)
-    endif()
 
     # Execute the script, leave the image extension decision to the test.
     # SVG is preferred, but PNG is better suited for some tests, like bitmap
     # patterns.
     execute_process(
-        COMMAND lua ${template} ${test_path} ${IMAGE_PATH} ${LCOV_PATH}
+        COMMAND ${LUA_COV_RUNNER} ${template} ${test_path} ${IMAGE_PATH}
+        RESULT_VARIABLE TEST_RESULT
         OUTPUT_VARIABLE TEST_OUTPUT
         ERROR_VARIABLE  TEST_ERROR
     )
-
-    # If there is something on stderr, exit.
-    if (NOT TEST_ERROR STREQUAL "")
-        message("${TEST_OUTPUT}")
-        message("${TEST_ERROR}")
+    if (TEST_RESULT OR NOT TEST_ERROR STREQUAL "")
+        message("Result: ${TEST_RESULT}")
+        if (NOT TEST_OUTPUT STREQUAL "")
+            message("Output: ${TEST_OUTPUT}")
+        endif()
+        if (NOT TEST_ERROR STREQUAL "")
+            message("Error:  ${TEST_ERROR}")
+        endif()
         if (STRICT_TESTS)
             message(FATAL_ERROR ${test_path} " An example test failed, aborting.")
         endif()
@@ -194,7 +231,7 @@
     # documentation under the image.
     if(NOT ${TEST_OUTPUT} STREQUAL "")
         set(TEST_DOC_CONTENT
-            "${TEST_DOC_CONTENT}\n--\n--**Usage example output**:\n--"
+            "${TEST_DOC_CONTENT}\n${DOC_LINE_PREFIX}\n${DOC_LINE_PREFIX}**Usage example output**:\n${DOC_LINE_PREFIX}"
         )
 
         # Markdown requires an empty line before and after, and 4 spaces.
@@ -202,22 +239,16 @@
             "\n${TEST_OUTPUT}"
             "${TEST_DOC_CONTENT}" TEST_DOC_CONTENT "    "
         )
-        set(TEST_DOC_CONTENT "${TEST_DOC_CONTENT}\n--")
+        set(TEST_DOC_CONTENT "${TEST_DOC_CONTENT}\n${DOC_LINE_PREFIX}")
     endif()
 
     # If there is some @* content, append it.
     set(TEST_DOC_CONTENT "${TEST_DOC_CONTENT}${TEST_POST_HEADER}")
 
     # Only add it if there is something to display.
-    if(NOT ${TEST_CODE} STREQUAL "\n--")
-        # Do not use the @usage tag, but 4 spaces.
-        file(READ ${test_path} tmp_content)
-        if(NOT tmp_content MATCHES "--DOC_NO_USAGE")
-            set(DOC_PREFIX "@usage")
-        endif()
-
-        escape_string(
-            " ${DOC_PREFIX}"
+    if(NOT ${TEST_CODE} STREQUAL "\n${DOC_LINE_PREFIX}")
+        escape_string(
+            " ${DOC_BLOCK_PREFIX}"
             "${TEST_DOC_CONTENT}" TEST_DOC_CONTENT ""
         )
 
@@ -231,12 +262,12 @@
 
 # Find and run all test files.
 file(GLOB_RECURSE test_files LIST_DIRECTORIES false
-    "${SOURCE_DIR}/tests/examples/*.lua")
+    "${TOP_SOURCE_DIR}/tests/examples/*.lua")
 foreach(file ${test_files})
     if ((NOT "${file}" MATCHES ".*/shims/.*")
         AND (NOT "${file}" MATCHES ".*/template.lua"))
 
-        file(RELATIVE_PATH relative_file "${SOURCE_DIR}" "${file}")
+        file(RELATIVE_PATH relative_file "${TOP_SOURCE_DIR}" "${file}")
         message(STATUS "Running ${relative_file}...")
 
         # Get the file name without the extension.
@@ -259,3 +290,5 @@
 endforeach()
 
 message(STATUS "Example tests passed.")
+
+# vim: filetype=cmake:expandtab:shiftwidth=4:tabstop=8:softtabstop=4:textwidth=80:foldmethod=marker
