=== debian/changelog ===
awesome (4.2-4) unstable; urgency=medium

  * Support for freedesktop.org menu. (Closes: #693135)
    - patch default awesomerc.lua to load/use freedesktop module if available
    - recommend awesome-extra, which includes freedesktop module
    - document change in NEWS
  * Fix formatting, spelling and urgency in NEWS.
  * Add libcairo-gobject2 to dependencies. (LP: #1589709)
  * Bump debhelper compatibility/dependency to 11.
  * Bump Standards-Version to 4.1.2.
  * Mention another way of customization in README.Debian. (Closes: #527115)

 -- Reiner Herrmann <reiner@reiner-h.de>  Wed, 27 Dec 2017 15:44:59 +0100

awesome (4.2-3) unstable; urgency=medium

  * Inform about switch to lua 5.3 in NEWS. (Closes: #880143)
  * Bump lua-lgi dependency to 0.9.2; older versions are broken on big endian
    64bit architectures like s390x. (Closes: #879941)

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 05 Nov 2017 12:12:19 +0100

awesome (4.2-2) unstable; urgency=low

  * New maintainer. (Closes: #867316)
  * Build against lua 5.3.
  * Update menu-method generator for lua 5.3.
  * Allow other session bus than dbus-x11. (Closes: #836080)
  * Move API documentation into -doc package. (Closes: #546688)
  * Remove ancient version restrictions.
  * Cherry-pick upstream fix for errors with keyboardlayout widget.
    (Closes: #877757)
  * Document copyright of wallpaper images in default theme.
  * Run unit tests during build.
    - add lua-busted and zsh to build dependencies.
  * Run integration tests as autopkgtest.

 -- Reiner Herrmann <reiner@reiner-h.de>  Mon, 23 Oct 2017 19:20:04 +0200

awesome (4.2-1) unstable; urgency=medium

  * QA upload.

  [ Reiner Herrmann ]
  * New upstream release (Closes: #858170).
  * debian/control:
    - bump Standards-Version to 4.1.1
    - update Homepage field
    - change Vcs-* URLs to https
  * Add upstream signing key.
  * Check upstream signature in watch file.
  * Fix spelling error found by lintian.
  * Register API documentation at doc-base.
  * Amend desktop file with Icon and Keywords entries.
  * Enable all hardening options.
  * Drop build status from documentation to remove privacy breach.
  * Sort table in documentation to build it reproducibly.
  * Honour SOURCE_DATE_EPOCH in generated images in documentation
    of calendar widget.
  * Add myself to debian/copyright.

  [ Julian Wollrath ]
  * Update build dependencies.
  * Bump required lua-lgi version to at least 0.8.0 (Closes: #852969).
  * Drop remove_useless_build_lgi_check.patch.
  * Refresh install-and-debian-menu.
  * Provide notification-daemon. (Closes: #734645)
  * Do not install README.md link. (Closes: #856442)

  [ Nicolas Boulenguez ]
  * Orphan the package (see #867316).
  * Run wrap-and-sort.
  * Stop overriding dh_installwm, priority 20 is the default.
  * Let watch file track github tags.
  * Switch to debhelper 10.
  * Switch to copyright format 1.0. Order like docs/00-authors.md.
  * Generate menu icon during build.

  [ Łukasz Stelmach ]
  * Add support for starting other window managers in Debian menu.
    (Closes: #856476)

 -- Reiner Herrmann <reiner@reiner-h.de>  Mon, 02 Oct 2017 23:57:00 +0200
