=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure: debian/awesome.xpm
	dh_auto_configure -- -DSYSCONFDIR=/etc

debian/awesome.xpm: icons/awesome32.png
	convert $< $@

override_dh_auto_test:
	# run unit tests here.
	# the generic check target also runs integration tests,
	# which are better suited as autopkgtest.
	$(MAKE) -C build check-unit
