=== debian/tests/control ===
# lua5.2 is explicitely added, because 5.3 doesn't currently provide lua (#863036)
Tests: integration.sh
Depends: awesome, lua5.2, xvfb, dbus-x11, xterm, xfonts-base, x11-xserver-utils, x11-utils, gir1.2-gtk-3.0, build-essential, libxcb1-dev, libxcb-util0-dev, libxcb-icccm4-dev
